; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .code

start:
   
; 

    call main
    inkey
    exit

; 

align 16

main proc

    LOCAL lcnt  :DWORD
    LOCAL mcnt  :DWORD      ; misaligned count
    LOCAL acnt  :DWORD      ; aligned count

    mov acnt, 0             ; zero both counters
    mov mcnt, 0

    invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

    push esi

    invoke SleepEx,1,0

    REPEAT 8

  ; ********************************************

    invoke GetTickCount
    push eax
    mov esi, 400000000
    jmp @F

  REPEAT 2048
    db 0,0,0,0,0,0,0,0  ; 16k inline padding
  ENDM

  align 4
  nop
  nop
  nop
  nop
  nop
  nop
  nop       ;;; 13 nops
  nop
  nop
  nop
  nop
  nop
  nop
  ; ---------------------------
  @@:
    mov lcnt, 0     ; short intensive loop
    sub esi, 1
    jnz @B
  ; ---------------------------
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add mcnt, eax
    print str$(eax)," misaligned",13,10

    invoke SleepEx,1,0

  ; ********************************************

    invoke GetTickCount
    push eax
    mov esi, 400000000
    jmp @F

  REPEAT 2048
    db 0,0,0,0,0,0,0,0  ; 16k inline padding
  ENDM

  align 4
  ; ---------------------------
  @@:
    mov lcnt, 0     ; short intensive loop
    sub esi, 1
    jnz @B
  ; ---------------------------
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add acnt, eax
    print str$(eax)," aligned",13,10

    invoke SleepEx,1,0

  ; ********************************************

    ENDM

    pop esi

    print "-----------------------------",13,10
    shr mcnt, 3
    print str$(mcnt)," misaligned average",13,10
    shr acnt, 3
    print str$(acnt)," aligned average",13,10
    print "-----------------------------",13,10

    invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    ret

main endp

; 

end start